<%
'*******************************************************************************
' Use to write a message to asp mail interface
' Interface includes ASPMAIL, JMAIL, CDONTS, CDOYSYS, OCXMAIL, CDOYSYS
' Must fill in array mailparms and pass it to Witemailmessage
'
' Copyright HK Programming. All rights reserved
' Verion 4.00
' March 11, 2008
'
' *********************************************************************************
dim mailtrace
const mailpassword=""
const mailuserid=""
'
dim mailfromname, mailfromaddress
dim mailtoname, mailtoaddress, mailsubject, mailbody
dim maildriver, mailsystem, mailhtmlformat, mailattachmentlist, mailerror
'
'
'******************************************************************************
' mail mailing subroutine. Uses case to go to correct mail driver
'*******************************************************************************
sub WritemailMessage (fromname, fromaddress, toname, toaddress, subject, body, imailtype, imailsystem, ihtmlformat, attachmentlist, mailerror)
on error resume next
dim i
mailerror=""
Dim traceflag
dim attachments(20), attachmentcount
dim mailtype
dim attach
Dim iConf, Flds
Dim mailer, rc
dim mailuserid, mailpassword
traceflag=readconfig("config_tracemail")
If attachmentlist<>"" then
   Converttoarray attachmentlist, attachments, attachmentcount,","
end if
mailhtmlformat=lcase(ihtmlformat)
mailtype=lcase(imailtype)
mailuserid=mailuserid
mailpassword=mailpassword
mailsystem=imailsystem
If lcase(traceflag)="yes" then
  Debugwrite "Mailtype=" & mailtype & " htmlformat=" & mailhtmlformat  & " system=" & mailsystem
  Debugwrite "To=" & toname & "(" & toaddress & ")"
  debugwrite "From=" & fromname & "("& fromaddress  &")" 
  debugwrite "Subject=" & subject
  debugwrite "Attachment Count=" & attachmentcount
  debugwrite "using mail driver=" & mailtype
  debugwrite "mailhtmlformat=" & mailhtmlformat  
  debugwrite body
end if  
'********************************************************************************
' ASPMAIL
'*******************************************************************************
 Select case  mailtype
  case "aspmail" 
     Set Mailer = Server.CreateObject("SMTPsvg.Mailer")
     if err.number<> 0 then
            mailerror= "ASPMAIL not installed.<br>"  &  err.description
            HandleMailError mailerror 
          exit sub
      end if
      Mailer.AddRecipient toname, toaddress
      Mailer.RemoteHost = mailsystem
      Mailer.FromName = fromname
      Mailer.FromAddress = fromAddress
      Mailer.Subject = subject
      Mailer.BodyText=body
      If mailhtmlformat="html" then	
       Mailer.ContentType = "text/html"
      end if 
      If attachmentcount>0 then
       for i = 0 to attachmentcount-1
            Mailer.AddAttachment attachments(i)
       next
      end if            
      If Mailer.SendMail then
         set Mailer=nothing
       else
         mailerror= "error sending with aspmail"
         mailerror=mailerror & "<br>" & mailer.response 
         Set mailer=nothing 
      end if
'********************************************************************************
' Microsoft CDONTS
'*******************************************************************************
   case  "cdonts"
        Set Mailer = Server.CreateObject("CDONTS.NewMail")
        if err.number<> 0 then
            mailerror= "CDONTS not installed.<br>"  &  err.description
            HandleMailError mailerror 
            exit sub
        end if
	Mailer.To = toaddress
        Mailer.From = fromname & " <" & fromaddress & ">"
	Mailer.Subject = subject
	Mailer.Body = body
        If mailhtmlformat="html" then	
          Mailer.BodyFormat = 0 
          Mailer.MailFormat = 0 
       end if       
       If attachmentcount>0 then
         for i = 0 to attachmentcount-1
         Mailer.AttachFile attachments(i)
         next
       end if  
       Mailer.Send
       set mailer=nothing
'********************************************************************************
' JMAIL
'*******************************************************************************
  case "jmail"
	Set Mailer = Server.CreateObject("JMail.SMTPMail")
        if err.number<> 0 then
            mailerror= "JMAIL not installed.<br>"  &  err.description
            exit sub
        end if
	Mailer.ServerAddress = mailsystem
	If mailpassword<>"" then 
          mailer.mailserverpassword=mailpassword
        end if
        if mailuserid<>"" then 
	    mailer.mailserverusername=mailuserid
        end if    
	Mailer.Sender = fromAddress
	Mailer.SenderName = fromname
	Mailer.AddRecipient toaddress
	Mailer.Subject = subject
        If mailhtmlformat="html" then	
         Mailer.ContentType = "text/html"
        end if       
	Mailer.Body = body
        If attachmentcount>0 then
         for i = 0 to attachmentcount-1
           Mailer.AddAttachment attachments(i)
           next
        end if            
        If Mailer.execute then
          set Mailer=nothing
        else
           mailerror= langmailerror & " " & my_toaddress
            set mailer=nothing 
        end if 
'********************************************************************************
' JMAIL  4.3 and 4.4
'*******************************************************************************        
  case "jmail44"
      Set Mailer = Server.CreateObject("JMail.Message")
      if err.number<> 0 then
        mailerror= "JMAIL44 not installed.<br>"  &  err.description
        exit sub
      end if
      Mailer.From = fromAddress
      Mailer.FromName = fromname
      Mailer.AddRecipient toaddress, toname
      Mailer.Subject = subject
      If mailpassword<>"" then 
         mailer.mailserverpassword=mailpassword
      end if
     if mailuserid<>"" then 
	    mailer.mailserverusername=mailuserid
     end if    
     If mailhtmlformat="html" then 
        Mailer.HTMLBody = body
     else
       Mailer.Body = body
     end if
     If attachmentcount>0 then
        for i = 0 to attachmentcount-1
          Mailer.AddAttachment attachments(i)
        next
    end if 
    If Mailer.Send(mailsystem) then
       set Mailer=nothing
    else
      mailerror=langmailerror & " " & my_toaddress
      HandleMailError mailerror 
      set mailer=nothing 
    end if 

        
   case "aspemail"
'********************************************************************************
' ASPEMAIL
'*******************************************************************************
	Set Mailer = Server.CreateObject("Persits.MailSender")
        if err.number<> 0 then
           mailerror= "ASPEMAIL not installed.<br>"  &  err.description
            HandleMailError mailerror 
           exit sub
        end if
 	Mailer.Host = mailsystem
	Mailer.From = fromAddress
	Mailer.FromName = fromname
	Mailer.AddAddress toaddress, toname
	Mailer.Subject = subject
        If mailhtmlformat="html" then	
           Mailer.IsHTML = TRUE
        end if       
       If attachmentcount>0 then
          for i = 0 to attachmentcount-1
            Mailer.AddAttachment attachments(i)
          next
        end if            
	Mailer.Body = body
	If Mailer.Send then
           set Mailer=nothing
        else
           mailerror= langmailerror & " " & my_toaddress
           HandleMailError mailerror 
           set mailer=nothing 
         end if 
 case "ocxmail"
'********************************************************************************
' OCXMAIL
'*******************************************************************************
	Set mailer = Server.CreateObject("ASPMAIL.ASPMailCtrl.1")
	if err.number<>0 then  
	  mailerror= "OCXMAIL not installed.<br>"  &  err.description
	  exit sub
	end if  
	If mailhtmlformat="html" then
       	       rc=Mailer.XHeader ("Content-Type", "text/html")
        end if
        attach=""
	If attachmentcount>0 then
	 for i = 1 to orderattachmentcount-1
	    If attach<>"" then
	        attach=attach & ","
	    end if    
	    attach=attach & attachments(i)
          next
        end if  
        if attach<>"" then 
		mailerror = mailer.SMAttach(mailsystem, toaddress, fromaddress, subject, body, attach)
	else
		mailerror = mailer.SendMail(mailsystem, toaddress, fromaddress, subject, body) 
	end if
	Set mailer=nothing
	If mailerror<>"" then
	     mailerror=readlang("langmailerror") & "<br> " & mailerror
             HandleMailError mailerror 
       	End If

case "cdosys"
    Const cdoSendUsingPort = 2
   set Mailer = CreateObject("CDO.Message")
   if err.number<>0 then  
	  mailerror= "CDOSYS not installed.<br>"  &  err.description
	  exit sub
   end if  

   set iConf = CreateObject("CDO.Configuration")
   Set Flds = iConf.Fields
   Flds.Item("http://schemas.microsoft.com/cdo/configuration/sendusing") = cdoSendUsingPort
   Flds.Item("http://schemas.microsoft.com/cdo/configuration/smtpserver") =mailsystem
   Flds.Item("http://schemas.microsoft.com/cdo/configuration/smtpconnectiontimeout") = 10
   if mailuserid > "" then
		flds.Item("http://schemas.microsoft.com/cdo/configuration/smtpauthenticate") = 1
		flds.Item("http://schemas.microsoft.com/cdo/configuration/sendusername") = mailuserid
   end if
  if mailpassword > "" then
		flds.Item("http://schemas.microsoft.com/cdo/configuration/sendpassword") = mailpassword
   end if

   Flds.Update
    Set mailer.Configuration = iConf
    mailer.To = toaddress 
    mailer.From = fromname & " <" & fromaddress & ">" 
    mailer.Subject = subject
     If attachmentcount>0 then
       for i = 0 to attachmentcount-1
           mailer.AddAttachment attachments(i)
       next
     end if            
    If mailhtmlformat="html" then
       mailer.HTMLBody = body
     Else
	mailer.TextBody = body
     End if
     mailer.Send
     Set Mailer=Nothing
      Set iConf=Nothing
  case else
    mailerror= "Unknown mail driver " & mailtype
    HandleMailError mailerror 
  end select  
end sub

Sub HandleMailerror (errormsg)
'debugwrite "handle mail error" & errormsg
session("mailerror")=errormsg
end sub

%>
